unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, OleCtrls, SHDocVw, Buttons, ComCtrls, Gauges;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    WebAddress: TEdit;
    buStop: TBitBtn;
    BuNewPage: TBitBtn;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    WebBrowser: TWebBrowser;
    BuDel: TBitBtn;
    StatusBar1: TStatusBar;
    BuGo: TBitBtn;
    BuGoForward: TBitBtn;
    BuGoBack: TBitBtn;
    Burefresh: TBitBtn;
    procedure WebAddressKeyPress(Sender: TObject; var Key: Char);
    procedure BuGoClick(Sender: TObject);
    procedure buStopClick(Sender: TObject);
    procedure BuNewPageClick(Sender: TObject);
    procedure BuDelClick(Sender: TObject);
    procedure PageControlChange(Sender: TObject);
    procedure WebBrowserStatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure WebBrowserNewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure BuGoForwardClick(Sender: TObject);
    procedure BuGoBackClick(Sender: TObject);
    procedure BurefreshClick(Sender: TObject);
    procedure WebBrowserTitleChange(Sender: TObject;
      const Text: WideString);
    procedure WebBrowserCommandStateChange(Sender: TObject;
      Command: Integer; Enable: WordBool);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    procedure CreateTab(PURL: string);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Tab: array[0..1000] of TTabSheet;
  Web: array[0..1000] of TWebBrowser;
  GoURL: string;
  pageSum: integer;
  DontDownLoad: boolean;

implementation

{$R *.dfm}

procedure TForm1.WebAddressKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
  begin
    if PageControl.Pages[PageControl.ActivePageIndex].Hint = '' then
      PageControl.Pages[PageControl.ActivePageIndex].Hint := WebAddress.Text;

    if PageControl.ActivePageIndex = 0 then
      WebBrowser.Navigate(WebAddress.Text)
    else
      Web[PageControl.ActivePage.Tag].Navigate(WebAddress.Text);

  end;
end;

procedure TForm1.BuGoClick(Sender: TObject);
begin
  if PageControl.Pages[PageControl.ActivePageIndex].Hint = '' then
    PageControl.Pages[PageControl.ActivePageIndex].Hint := WebAddress.Text;

  if PageControl.ActivePageIndex = 0 then
    WebBrowser.Navigate(WebAddress.Text)
  else
    Web[PageControl.ActivePage.Tag].Navigate(WebAddress.Text);
end;

procedure TForm1.buStopClick(Sender: TObject);
begin
  if PageControl.ActivePageIndex = 0 then
    WebBrowser.Stop
  else
    Web[PageControl.ActivePage.Tag].Stop;
end;

procedure TForm1.BuNewPageClick(Sender: TObject);
begin
  CreateTab('');
end;

procedure TForm1.BuDelClick(Sender: TObject);
var i, j: integer;
begin
  if PageControl.ActivePageIndex > 0 then
  begin
    j := PageControl.ActivePage.Tag;
    Tab[j].Free;
    PageControl.ActivePageIndex := PageControl.PageCount - 1;
  end;
end;

procedure TForm1.PageControlChange(Sender: TObject);
begin
  if PageControl.Pages[PageControl.ActivePageIndex].Hint <> '' then
    WebAddress.Text := PageControl.Pages[PageControl.ActivePageIndex].Hint
  else
    webaddress.Text := '';
end;

procedure TForm1.CreateTab(PURL: string);
begin
  tab[pageSum] := ttabsheet.create(PageControl);
  tab[pageSum].pagecontrol := pagecontrol;
  tab[pageSum].caption := '     ť     ';
  tab[pagesum].Tag := pageSum;
  web[pageSum] := TWebBrowser.Create(nil);
  TWinControl(web[pageSum]).Parent := PageControl.Pages[PageControl.PageCount - 1];

  web[pageSum].Align := webbrowser.Align;
  web[pageSum].TheaterMode := webbrowser.TheaterMode;

  web[pageSum].OnStatusTextChange := webbrowser.OnStatusTextChange;
  web[pageSum].OnNewWindow2 := webbrowser.OnNewWindow2;
  web[pageSum].OnTitleChange := webbrowser.OnTitleChange;
  web[pageSum].OnBeforeNavigate2 := webbrowser.OnBeforeNavigate2;
  web[pageSum].OnCommandStateChange := webbrowser.OnCommandStateChange;

  Web[pageSum].Navigate(PURL);

  if purl = '' then
  begin
    PageControl.ActivePageIndex := pagecontrol.PageCount - 1;
    WebAddress.Text := '';
    webaddress.SetFocus;
  end
  else
  begin
    tab[pageSum].Hint := PURL;
    PageControl.ActivePageIndex := pagecontrol.PageCount - 1;
  end;
  pagesum := pageSum + 1;

end;

procedure TForm1.WebBrowserStatusTextChange(Sender: TObject;
  const Text: WideString);
begin

  StatusBar1.Panels.Items[1].Text := text;
 {
  if pos('.gif', text) > 0 then
    DontDownLoad := true
  else if pos('.jpg', text) > 0 then
    DontDownLoad := true
  else if pos('.swf', text) > 0 then
    DontDownLoad := true
  else if pos('.bmp', text) > 0 then
    DontDownLoad := true
  else
    DontDownLoad := false;

  if DontDownLoad = true then
  begin
    if PageControl.ActivePageIndex = 0 then
      webbrowser.Stop
    else
      web[PageControl.ActivePage.Tag].Stop;
  end;
  }

  if copy(text, 1, 4) = 'http' then
    GoURL := text;

end;

procedure TForm1.WebBrowserNewWindow2(Sender: TObject;
  var ppDisp: IDispatch; var Cancel: WordBool);
begin
  CreateTab(gourl);
  Cancel := true;
end;

procedure TForm1.BuGoForwardClick(Sender: TObject);
begin
  try
    if PageControl.ActivePageIndex = 0 then
      WebBrowser.GoForward
    else
      Web[PageControl.ActivePage.Tag].GoForward;
  except
  end;
end;

procedure TForm1.BuGoBackClick(Sender: TObject);
begin
  try
    if PageControl.ActivePageIndex = 0 then
      WebBrowser.GoBack
    else
      Web[PageControl.ActivePage.Tag].GoBack;
  except
  end;
end;

procedure TForm1.BurefreshClick(Sender: TObject);
begin
  if PageControl.ActivePageIndex = 0 then
    WebBrowser.Refresh
  else
    Web[PageControl.ActivePage.Tag].Refresh;
end;

procedure TForm1.WebBrowserTitleChange(Sender: TObject;
  const Text: WideString);
begin
 // if PageControl.ActivePageIndex = 0 then
  PageControl.ActivePage.Caption := copy(Text, 1, 10);
  //else
  Tab[PageControl.ActivePage.Tag].Caption := copy(Text, 1, 10);
end;

procedure TForm1.WebBrowserCommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
begin
  if Command = CSC_NAVIGATEFORWARD then
    BuGoForward.Enabled := Enable
  else if command = CSC_NAVIGATEBACK then
    BuGoBack.Enabled := enable;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  pageSum := 1;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  WebAddress.Width := form1.Width - 20;
end;

end.

